<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.ImageControls</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Prelude</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Int</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Utils</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">with</span></span><span class="hs-special">)</span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.C.String</span></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.C.Types</span></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Memorable.html"><span class="hs-identifier">Memorable</span></a></span><span>
</span><span id="line-12"></span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw.Types</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">SDL.Raw</span></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">SDL</span></span><span>
</span><span id="line-15"></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-17"></span><span>
</span><span id="line-18"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#createImage"><span class="hs-identifier hs-type">createImage</span></a></span><span>
</span><span id="line-19"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190271"><span class="annot"><a href="#local-6989586621679190271"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-20"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190271"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-21"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-23"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FormatEnum"><span class="hs-identifier hs-type">GPU.FormatEnum</span></a></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190271"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span id="createImage"><span class="annot"><span class="annottext">createImage :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Uint16 -&gt; Uint16 -&gt; FormatEnum -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#createImage"><span class="hs-identifier hs-var hs-var">createImage</span></a></span></span><span> </span><span id="local-6989586621679190186"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190186"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679190185"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190185"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span id="local-6989586621679190184"><span class="annot"><span class="annottext">FormatEnum
</span><a href="#local-6989586621679190184"><span class="hs-identifier hs-var">fmt</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Uint16 -&gt; Uint16 -&gt; FormatEnum -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.ImageControls.html#createImage"><span class="hs-identifier hs-var">GPU.createImage</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190186"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190185"><span class="hs-identifier hs-var">h</span></a></span><span> </span><span class="annot"><span class="annottext">FormatEnum
</span><a href="#local-6989586621679190184"><span class="hs-identifier hs-var">fmt</span></a></span><span>
</span><span id="line-26"></span><span>
</span><span id="line-27"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#createImageUsingTexture"><span class="hs-identifier hs-type">createImageUsingTexture</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190260"><span class="annot"><a href="#local-6989586621679190260"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-29"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190260"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-30"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#TextureHandle"><span class="hs-identifier hs-type">GPU.TextureHandle</span></a></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span> </span><span class="hs-comment">-- ^ take_ownership</span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190260"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-33"></span><span id="createImageUsingTexture"><span class="annot"><span class="annottext">createImageUsingTexture :: forall (m :: * -&gt; *).
MonadIO m =&gt;
TextureHandle -&gt; Bool -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#createImageUsingTexture"><span class="hs-identifier hs-var hs-var">createImageUsingTexture</span></a></span></span><span> </span><span id="local-6989586621679190178"><span class="annot"><span class="annottext">TextureHandle
</span><a href="#local-6989586621679190178"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679190177"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679190177"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">TextureHandle -&gt; Bool -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.ImageControls.html#createImageUsingTexture"><span class="hs-identifier hs-var">GPU.createImageUsingTexture</span></a></span><span> </span><span class="annot"><span class="annottext">TextureHandle
</span><a href="#local-6989586621679190178"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679190177"><span class="hs-identifier hs-var">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-34"></span><span>
</span><span id="line-35"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#loadImage"><span class="hs-identifier hs-type">loadImage</span></a></span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190256"><span class="annot"><a href="#local-6989586621679190256"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-37"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190256"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">FilePath</span></span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190256"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-40"></span><span id="loadImage"><span class="annot"><span class="annottext">loadImage :: forall (m :: * -&gt; *). MonadIO m =&gt; FilePath -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#loadImage"><span class="hs-identifier hs-var hs-var">loadImage</span></a></span></span><span> </span><span id="local-6989586621679190171"><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679190171"><span class="hs-identifier hs-var">fp</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a. FilePath -&gt; (CString -&gt; IO a) -&gt; IO a
</span><span class="hs-identifier hs-var">withCString</span></span><span> </span><span class="annot"><span class="annottext">FilePath
</span><a href="#local-6989586621679190171"><span class="hs-identifier hs-var">fp</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">CString -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.ImageControls.html#loadImage"><span class="hs-identifier hs-var">GPU.loadImage</span></a></span><span>
</span><span id="line-41"></span><span>
</span><span id="line-42"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#createAliasImage"><span class="hs-identifier hs-type">createAliasImage</span></a></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190251"><span class="annot"><a href="#local-6989586621679190251"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-44"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190251"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190251"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-47"></span><span id="createAliasImage"><span class="annot"><span class="annottext">createAliasImage :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#createAliasImage"><span class="hs-identifier hs-var hs-var">createAliasImage</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.ImageControls.html#createAliasImage"><span class="hs-identifier hs-var">GPU.createAliasImage</span></a></span><span>
</span><span id="line-48"></span><span>
</span><span id="line-49"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#copyImage"><span class="hs-identifier hs-type">copyImage</span></a></span><span>
</span><span id="line-50"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190162"><span class="annot"><a href="#local-6989586621679190162"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-51"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190162"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190162"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-54"></span><span id="copyImage"><span class="annot"><span class="annottext">copyImage :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Image)
</span><a href="SDL.GPU.Simple.ImageControls.html#copyImage"><span class="hs-identifier hs-var hs-var">copyImage</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Image)
</span><a href="SDL.GPU.C.ImageControls.html#copyImage"><span class="hs-identifier hs-var">GPU.copyImage</span></a></span><span>
</span><span id="line-55"></span><span>
</span><span id="line-56"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#freeImage"><span class="hs-identifier hs-type">freeImage</span></a></span><span>
</span><span id="line-57"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190245"><span class="annot"><a href="#local-6989586621679190245"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-58"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190245"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-59"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190245"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-61"></span><span id="freeImage"><span class="annot"><span class="annottext">freeImage :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#freeImage"><span class="hs-identifier hs-var hs-var">freeImage</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#freeImage"><span class="hs-identifier hs-var">GPU.freeImage</span></a></span><span>
</span><span id="line-62"></span><span>
</span><span id="line-63"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setImageVirtualResolution"><span class="hs-identifier hs-type">setImageVirtualResolution</span></a></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190243"><span class="annot"><a href="#local-6989586621679190243"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-65"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190243"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-67"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190243"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-70"></span><span id="setImageVirtualResolution"><span class="annot"><span class="annottext">setImageVirtualResolution :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Uint16 -&gt; Uint16 -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setImageVirtualResolution"><span class="hs-identifier hs-var hs-var">setImageVirtualResolution</span></a></span></span><span> </span><span id="local-6989586621679190151"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190151"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190150"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190150"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679190149"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190149"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; Uint16 -&gt; Uint16 -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setImageVirtualResolution"><span class="hs-identifier hs-var">GPU.setImageVirtualResolution</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190151"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190150"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679190149"><span class="hs-identifier hs-var">h</span></a></span><span>
</span><span id="line-71"></span><span>
</span><span id="line-72"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#unsetImageVirtualResolution"><span class="hs-identifier hs-type">unsetImageVirtualResolution</span></a></span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190146"><span class="annot"><a href="#local-6989586621679190146"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-74"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190146"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190146"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-77"></span><span id="unsetImageVirtualResolution"><span class="annot"><span class="annottext">unsetImageVirtualResolution :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#unsetImageVirtualResolution"><span class="hs-identifier hs-var hs-var">unsetImageVirtualResolution</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#unsetImageVirtualResolution"><span class="hs-identifier hs-var">GPU.unsetImageVirtualResolution</span></a></span><span>
</span><span id="line-78"></span><span>
</span><span id="line-79"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#updateImage"><span class="hs-identifier hs-type">updateImage</span></a></span><span>
</span><span id="line-80"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190240"><span class="annot"><a href="#local-6989586621679190240"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-81"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190240"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-83"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ image_rect</span><span>
</span><span id="line-84"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span>
</span><span id="line-85"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span> </span><span class="hs-comment">-- ^ surface_rect</span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190240"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-87"></span><span id="updateImage"><span class="annot"><span class="annottext">updateImage :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Rect -&gt; Surface -&gt; Rect -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#updateImage"><span class="hs-identifier hs-var hs-var">updateImage</span></a></span></span><span> </span><span id="local-6989586621679190136"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190136"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190135"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190135"><span class="hs-identifier hs-var">img_rect</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">SDL.Surface</span></span><span> </span><span id="local-6989586621679190133"><span class="annot"><span class="annottext">Ptr Surface
</span><a href="#local-6989586621679190133"><span class="hs-identifier hs-var">s</span></a></span></span><span> </span><span class="annot"><span class="annottext">Maybe (IOVector Word8)
</span><span class="hs-identifier">_</span></span><span class="hs-special">)</span><span> </span><span id="local-6989586621679190132"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190132"><span class="hs-identifier hs-var">s_rect</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-88"></span><span>  </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190135"><span class="hs-identifier hs-var">img_rect</span></a></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190131"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190131"><span class="hs-identifier hs-var">pir</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679190132"><span class="hs-identifier hs-var">s_rect</span></a></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190130"><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190130"><span class="hs-identifier hs-var">ssr</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-89"></span><span>    </span><span class="annot"><span class="annottext">Ptr Image -&gt; Ptr Rect -&gt; Ptr Surface -&gt; Ptr Rect -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#updateImage"><span class="hs-identifier hs-var">GPU.updateImage</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190136"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190131"><span class="hs-identifier hs-var">pir</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Surface
</span><a href="#local-6989586621679190133"><span class="hs-identifier hs-var">s</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Rect
</span><a href="#local-6989586621679190130"><span class="hs-identifier hs-var">ssr</span></a></span><span>
</span><span id="line-90"></span><span>
</span><span id="line-91"></span><span class="hs-comment">-- TODO: updateImageBytes</span><span>
</span><span id="line-92"></span><span class="hs-comment">-- TODO: replaceImage</span><span>
</span><span id="line-93"></span><span class="hs-comment">-- TODO: saveImage</span><span>
</span><span id="line-94"></span><span class="hs-comment">-- TODO: saveImageRW</span><span>
</span><span id="line-95"></span><span>
</span><span id="line-96"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#generateMipmaps"><span class="hs-identifier hs-type">generateMipmaps</span></a></span><span>
</span><span id="line-97"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190127"><span class="annot"><a href="#local-6989586621679190127"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-98"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190127"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-99"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-100"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190127"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-101"></span><span id="generateMipmaps"><span class="annot"><span class="annottext">generateMipmaps :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#generateMipmaps"><span class="hs-identifier hs-var hs-var">generateMipmaps</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#generateMipmaps"><span class="hs-identifier hs-var">GPU.generateMipmaps</span></a></span><span>
</span><span id="line-102"></span><span>
</span><span id="line-103"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setColor"><span class="hs-identifier hs-type">setColor</span></a></span><span>
</span><span id="line-104"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190230"><span class="annot"><a href="#local-6989586621679190230"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-105"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190230"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-106"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-107"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">GPU.Color</span></span><span>
</span><span id="line-108"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190230"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-109"></span><span id="setColor"><span class="annot"><span class="annottext">setColor :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; Color -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setColor"><span class="hs-identifier hs-var hs-var">setColor</span></a></span></span><span> </span><span id="local-6989586621679190118"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190118"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190117"><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679190117"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679190117"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; Ptr Color -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setColor"><span class="hs-identifier hs-var">GPU.setColor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190118"><span class="hs-identifier hs-var">img</span></a></span><span>
</span><span id="line-110"></span><span>
</span><span id="line-111"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#unsetColor"><span class="hs-identifier hs-type">unsetColor</span></a></span><span>
</span><span id="line-112"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190114"><span class="annot"><a href="#local-6989586621679190114"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-113"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190114"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-114"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-115"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190114"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-116"></span><span id="unsetColor"><span class="annot"><span class="annottext">unsetColor :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#unsetColor"><span class="hs-identifier hs-var hs-var">unsetColor</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#unsetColor"><span class="hs-identifier hs-var">GPU.unsetColor</span></a></span><span>
</span><span id="line-117"></span><span>
</span><span id="line-118"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#getBlending"><span class="hs-identifier hs-type">getBlending</span></a></span><span>
</span><span id="line-119"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190226"><span class="annot"><a href="#local-6989586621679190226"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-120"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190226"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-121"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-122"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190226"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-123"></span><span id="getBlending"><span class="annot"><span class="annottext">getBlending :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m Bool
</span><a href="SDL.GPU.Simple.ImageControls.html#getBlending"><span class="hs-identifier hs-var hs-var">getBlending</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO Bool
</span><a href="SDL.GPU.C.ImageControls.html#getBlending"><span class="hs-identifier hs-var">GPU.getBlending</span></a></span><span>
</span><span id="line-124"></span><span>
</span><span id="line-125"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setBlending"><span class="hs-identifier hs-type">setBlending</span></a></span><span>
</span><span id="line-126"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190219"><span class="annot"><a href="#local-6989586621679190219"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-127"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190219"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-128"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-129"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-130"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190219"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-131"></span><span id="setBlending"><span class="annot"><span class="annottext">setBlending :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; Bool -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setBlending"><span class="hs-identifier hs-var hs-var">setBlending</span></a></span></span><span> </span><span id="local-6989586621679190095"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190095"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190094"><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679190094"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; Bool -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setBlending"><span class="hs-identifier hs-var">GPU.setBlending</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190095"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span> </span><span class="annot"><span class="annottext">Bool
</span><a href="#local-6989586621679190094"><span class="hs-identifier hs-var">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-132"></span><span>
</span><span id="line-133"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setBlendFunction"><span class="hs-identifier hs-type">setBlendFunction</span></a></span><span>
</span><span id="line-134"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190217"><span class="annot"><a href="#local-6989586621679190217"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-135"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190217"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-136"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-137"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ source_color</span><span>
</span><span id="line-138"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ dest_color</span><span>
</span><span id="line-139"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ source_alpha</span><span>
</span><span id="line-140"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendFuncEnum"><span class="hs-identifier hs-type">GPU.BlendFuncEnum</span></a></span><span> </span><span class="hs-comment">-- ^ dest_alpha</span><span>
</span><span id="line-141"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190217"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-142"></span><span id="setBlendFunction"><span class="annot"><span class="annottext">setBlendFunction :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setBlendFunction"><span class="hs-identifier hs-var hs-var">setBlendFunction</span></a></span></span><span> </span><span id="local-6989586621679190089"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190089"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190088"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190088"><span class="hs-identifier hs-var">f1</span></a></span></span><span> </span><span id="local-6989586621679190087"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190087"><span class="hs-identifier hs-var">f2</span></a></span></span><span> </span><span id="local-6989586621679190086"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190086"><span class="hs-identifier hs-var">f3</span></a></span></span><span> </span><span id="local-6989586621679190085"><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190085"><span class="hs-identifier hs-var">f4</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; BlendFuncEnum
-&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setBlendFunction"><span class="hs-identifier hs-var">GPU.setBlendFunction</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190089"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190088"><span class="hs-identifier hs-var">f1</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190087"><span class="hs-identifier hs-var">f2</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190086"><span class="hs-identifier hs-var">f3</span></a></span><span> </span><span class="annot"><span class="annottext">BlendFuncEnum
</span><a href="#local-6989586621679190085"><span class="hs-identifier hs-var">f4</span></a></span><span>
</span><span id="line-143"></span><span>
</span><span id="line-144"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setBlendEquation"><span class="hs-identifier hs-type">setBlendEquation</span></a></span><span>
</span><span id="line-145"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190214"><span class="annot"><a href="#local-6989586621679190214"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-146"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190214"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-147"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-148"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendEqEnum"><span class="hs-identifier hs-type">GPU.BlendEqEnum</span></a></span><span> </span><span class="hs-comment">-- ^ color_equation</span><span>
</span><span id="line-149"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendEqEnum"><span class="hs-identifier hs-type">GPU.BlendEqEnum</span></a></span><span> </span><span class="hs-comment">-- ^ alpha_equation</span><span>
</span><span id="line-150"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190214"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-151"></span><span id="setBlendEquation"><span class="annot"><span class="annottext">setBlendEquation :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; BlendEqEnum -&gt; BlendEqEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setBlendEquation"><span class="hs-identifier hs-var hs-var">setBlendEquation</span></a></span></span><span> </span><span id="local-6989586621679190080"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190080"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190079"><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679190079"><span class="hs-identifier hs-var">e1</span></a></span></span><span> </span><span id="local-6989586621679190078"><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679190078"><span class="hs-identifier hs-var">e2</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; BlendEqEnum -&gt; BlendEqEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setBlendEquation"><span class="hs-identifier hs-var">GPU.setBlendEquation</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190080"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679190079"><span class="hs-identifier hs-var">e1</span></a></span><span> </span><span class="annot"><span class="annottext">BlendEqEnum
</span><a href="#local-6989586621679190078"><span class="hs-identifier hs-var">e2</span></a></span><span>
</span><span id="line-152"></span><span>
</span><span id="line-153"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setBlendMode"><span class="hs-identifier hs-type">setBlendMode</span></a></span><span>
</span><span id="line-154"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190211"><span class="annot"><a href="#local-6989586621679190211"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-155"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190211"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-156"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-157"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#BlendPresetEnum"><span class="hs-identifier hs-type">GPU.BlendPresetEnum</span></a></span><span> </span><span class="hs-comment">-- ^ mode</span><span>
</span><span id="line-158"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190211"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-159"></span><span id="setBlendMode"><span class="annot"><span class="annottext">setBlendMode :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; BlendPresetEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setBlendMode"><span class="hs-identifier hs-var hs-var">setBlendMode</span></a></span></span><span> </span><span id="local-6989586621679190073"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190073"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190072"><span class="annot"><span class="annottext">BlendPresetEnum
</span><a href="#local-6989586621679190072"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; BlendPresetEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setBlendMode"><span class="hs-identifier hs-var">GPU.setBlendMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190073"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">BlendPresetEnum
</span><a href="#local-6989586621679190072"><span class="hs-identifier hs-var">m</span></a></span><span>
</span><span id="line-160"></span><span>
</span><span id="line-161"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setImageFilter"><span class="hs-identifier hs-type">setImageFilter</span></a></span><span>
</span><span id="line-162"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190208"><span class="annot"><a href="#local-6989586621679190208"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-163"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190208"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-164"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-165"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#FilterEnum"><span class="hs-identifier hs-type">GPU.FilterEnum</span></a></span><span> </span><span class="hs-comment">-- ^ filter</span><span>
</span><span id="line-166"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190208"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-167"></span><span id="setImageFilter"><span class="annot"><span class="annottext">setImageFilter :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; FilterEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setImageFilter"><span class="hs-identifier hs-var hs-var">setImageFilter</span></a></span></span><span> </span><span id="local-6989586621679190067"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190067"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190066"><span class="annot"><span class="annottext">FilterEnum
</span><a href="#local-6989586621679190066"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; FilterEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setImageFilter"><span class="hs-identifier hs-var">GPU.setImageFilter</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190067"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">FilterEnum
</span><a href="#local-6989586621679190066"><span class="hs-identifier hs-var">f</span></a></span><span>
</span><span id="line-168"></span><span>
</span><span id="line-169"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setAnchor"><span class="hs-identifier hs-type">setAnchor</span></a></span><span>
</span><span id="line-170"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190205"><span class="annot"><a href="#local-6989586621679190205"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-171"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190205"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-172"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-173"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_x</span><span>
</span><span id="line-174"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_y</span><span>
</span><span id="line-175"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190205"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-176"></span><span id="setAnchor"><span class="annot"><span class="annottext">setAnchor :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setAnchor"><span class="hs-identifier hs-var hs-var">setAnchor</span></a></span></span><span> </span><span id="local-6989586621679190061"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190061"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190060"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190060"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190059"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190059"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setAnchor"><span class="hs-identifier hs-var">GPU.setAnchor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190061"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190060"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190059"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-177"></span><span>
</span><span id="line-178"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#getAnchor"><span class="hs-identifier hs-type">getAnchor</span></a></span><span>
</span><span id="line-179"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190202"><span class="annot"><a href="#local-6989586621679190202"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-180"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190202"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-181"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-182"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_x</span><span>
</span><span id="line-183"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_y</span><span>
</span><span id="line-184"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190202"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-185"></span><span id="getAnchor"><span class="annot"><span class="annottext">getAnchor :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; Ptr Float -&gt; Ptr Float -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#getAnchor"><span class="hs-identifier hs-var hs-var">getAnchor</span></a></span></span><span> </span><span id="local-6989586621679190054"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190054"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190053"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190053"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190052"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190052"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; Ptr Float -&gt; Ptr Float -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#getAnchor"><span class="hs-identifier hs-var">GPU.getAnchor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190054"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190053"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190052"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-186"></span><span>
</span><span id="line-187"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#getSnapMode"><span class="hs-identifier hs-type">getSnapMode</span></a></span><span>
</span><span id="line-188"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190200"><span class="annot"><a href="#local-6989586621679190200"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-189"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190200"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-190"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-191"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190200"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#SnapEnum"><span class="hs-identifier hs-type">GPU.SnapEnum</span></a></span><span>
</span><span id="line-192"></span><span id="getSnapMode"><span class="annot"><span class="annottext">getSnapMode :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m SnapEnum
</span><a href="SDL.GPU.Simple.ImageControls.html#getSnapMode"><span class="hs-identifier hs-var hs-var">getSnapMode</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO SnapEnum
</span><a href="SDL.GPU.C.ImageControls.html#getSnapMode"><span class="hs-identifier hs-var">GPU.getSnapMode</span></a></span><span>
</span><span id="line-193"></span><span>
</span><span id="line-194"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setSnapMode"><span class="hs-identifier hs-type">setSnapMode</span></a></span><span>
</span><span id="line-195"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190197"><span class="annot"><a href="#local-6989586621679190197"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-196"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190197"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-197"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-198"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#SnapEnum"><span class="hs-identifier hs-type">GPU.SnapEnum</span></a></span><span>
</span><span id="line-199"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190197"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-200"></span><span id="setSnapMode"><span class="annot"><span class="annottext">setSnapMode :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; SnapEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setSnapMode"><span class="hs-identifier hs-var hs-var">setSnapMode</span></a></span></span><span> </span><span id="local-6989586621679190043"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190043"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190042"><span class="annot"><span class="annottext">SnapEnum
</span><a href="#local-6989586621679190042"><span class="hs-identifier hs-var">m</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; SnapEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setSnapMode"><span class="hs-identifier hs-var">GPU.setSnapMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190043"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">SnapEnum
</span><a href="#local-6989586621679190042"><span class="hs-identifier hs-var">m</span></a></span><span>
</span><span id="line-201"></span><span>
</span><span id="line-202"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#setWrapMode"><span class="hs-identifier hs-type">setWrapMode</span></a></span><span>
</span><span id="line-203"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190195"><span class="annot"><a href="#local-6989586621679190195"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-204"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190195"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-205"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-206"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#WrapEnum"><span class="hs-identifier hs-type">GPU.WrapEnum</span></a></span><span> </span><span class="hs-comment">-- ^ wrap_mode_x  </span><span>
</span><span id="line-207"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#WrapEnum"><span class="hs-identifier hs-type">GPU.WrapEnum</span></a></span><span> </span><span class="hs-comment">-- ^ wrap_mode_y</span><span>
</span><span id="line-208"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190195"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-209"></span><span id="setWrapMode"><span class="annot"><span class="annottext">setWrapMode :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Image -&gt; WrapEnum -&gt; WrapEnum -&gt; m ()
</span><a href="SDL.GPU.Simple.ImageControls.html#setWrapMode"><span class="hs-identifier hs-var hs-var">setWrapMode</span></a></span></span><span> </span><span id="local-6989586621679190037"><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190037"><span class="hs-identifier hs-var">img</span></a></span></span><span> </span><span id="local-6989586621679190036"><span class="annot"><span class="annottext">WrapEnum
</span><a href="#local-6989586621679190036"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190035"><span class="annot"><span class="annottext">WrapEnum
</span><a href="#local-6989586621679190035"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; WrapEnum -&gt; WrapEnum -&gt; IO ()
</span><a href="SDL.GPU.C.ImageControls.html#setWrapMode"><span class="hs-identifier hs-var">GPU.setWrapMode</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Image
</span><a href="#local-6989586621679190037"><span class="hs-identifier hs-var">img</span></a></span><span> </span><span class="annot"><span class="annottext">WrapEnum
</span><a href="#local-6989586621679190036"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">WrapEnum
</span><a href="#local-6989586621679190035"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-210"></span><span>
</span><span id="line-211"></span><span class="annot"><a href="SDL.GPU.Simple.ImageControls.html#getTextureHandle"><span class="hs-identifier hs-type">getTextureHandle</span></a></span><span>
</span><span id="line-212"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190192"><span class="annot"><a href="#local-6989586621679190192"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-213"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190192"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-214"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-215"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190192"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#TextureHandle"><span class="hs-identifier hs-type">GPU.TextureHandle</span></a></span><span>
</span><span id="line-216"></span><span id="getTextureHandle"><span class="annot"><span class="annottext">getTextureHandle :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m TextureHandle
</span><a href="SDL.GPU.Simple.ImageControls.html#getTextureHandle"><span class="hs-identifier hs-var hs-var">getTextureHandle</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO TextureHandle
</span><a href="SDL.GPU.C.ImageControls.html#getTextureHandle"><span class="hs-identifier hs-var">GPU.getTextureHandle</span></a></span><span>
</span><span id="line-217"></span></pre></body></html>